<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PopenerimaanService;
use App\Http\Services\ApplicationparameterService;
use App\Http\Validators\PopenerimaanValidator;
/* use App\Http\Services\KapalService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\UsersService; */
use App\Http\Services\PenerimaanbarangService; 
use App\Http\Services\VoyagesService;

class PopenerimaanController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $appParam;
    /* private $lokasiitem;
    private $users; */
    protected $penerimaanbarang;
    private $voyage;

    /**
     * Popenerimaan constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PopenerimaanService();
        $this->validator = new PopenerimaanValidator();
        $this->appParam = new ApplicationparameterService();
        /* $this->lokasiitem = new LokasiitemService();
        $this->users = new UsersService(); */
        $this->voyage = new VoyagesService();
        $this->penerimaanbarang = new PenerimaanbarangService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/popenerimaan")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "poNumber" => "No PO"
            , "date" => "Tanggal PO"
            , "status" => "Status"
            , "quantity" => "quantity"
        ];
        $this->data["criteria"] = [
            "poNumber" => "No PO"
            , "date" => "Tanggal PO"
            , "status" => "Status"
            , "quantity" => "quantity"
        ];
        $this->data["ordering"] = [
            "poNumber:asc" => "No Transaksi &uarr;"
            , "poNumber:desc" => "No Transaksi &darr;"
            , "date:asc" => "Tanngal PO &uarr;"
            , "date:desc" => "Tanngal PO &darr;"
        ];
        $input = $request->all();
        $this->data["popenerimaans"] = $this->baseService->paging($request);
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        return view("modules.popenerimaan.popenerimaan_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {       
        $this->data["popenerimaan"] = $this->baseService->show($id);
        return view("modules.popenerimaan.popenerimaan_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            DB::commit();
            $this->baseService->update($id, $request->all());
            return redirect()->to("administrator/popenerimaan")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        
        return view("modules.popenerimaan.popenerimaan_create", $this->data);
    }

    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {        
        $this->data["popenerimaan"] = $this->baseService->show($id);
        if($this->data["popenerimaan"]) {
            $this->data["penerimaanbarangs"] = $this->penerimaanbarang->showBasedOnPoNumber($request, $this->data["popenerimaan"]);
            return view("modules.popenerimaan.popenerimaan_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function generateLotNumber() {
        $lotNumber = $this->appParam->generateLotNumber();
        echo json_encode($lotNumber);
    }

}